package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.OrgType;
import com.sa.ibiz.demo.demo.service.OrgTypeService;
import com.sa.ibiz.demo.demo.service.dto.OrgTypeSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/orgtype")
public class OrgTypeResource
{
	@Autowired
	private OrgTypeService service;


	@PostMapping(value = "/remove")
	public ResponseEntity<OrgType> remove(@Validated @RequestBody OrgType data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("组织类型[remove]操作发生错误","OrgType",data.getOrgtypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<OrgType> get(@Validated @PathVariable String id){
		OrgType data=new OrgType();
		data.setOrgtypeid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("组织类型[get]操作发生错误","OrgType",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<OrgType> create(@Validated @RequestBody OrgType data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("组织类型[create]操作发生错误","OrgType",data.getOrgtypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<OrgType> update(@Validated @RequestBody OrgType data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("组织类型[update]操作发生错误","OrgType",data.getOrgtypeid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<OrgType> getDraft(@Validated @RequestBody OrgType data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("组织类型[getDraft]操作发生错误","OrgType","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<OrgType> checkKey(@Validated @RequestBody OrgType data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("组织类型[checkKey]操作发生错误","OrgType",data.getOrgtypeid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<OrgType>> searchDefaultPage(@Validated @RequestBody OrgTypeSearchFilter filter){
		Page<OrgType> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<OrgType>> listDefault(@Validated @RequestBody OrgTypeSearchFilter filter){
		List<OrgType> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
